#ifndef OBJECT_H_
#define OBJECT_H_

#include <graphx.h>
#include "sprite.h"

typedef struct Scale {
    int x;
    int y;
} Scale;

typedef struct Object Object;

struct Object {
    int id;
    int x;
    int y;
    Scale scale;
    Sprite* sprite;
    void* data;
    size_t data_size;

    int (*height)(Object*);
    int (*width)(Object*);
    void (*draw)(Object*);
    void (*update)(Object*);
    void (*load)(Object*);
};

void Object_draw(Object* self);
void free_Object(Object* self);
Object* new_Object(int x, int y);

#endif
