#ifndef SCENE_H_
#define SCENE_H_

#include "vector.h"
#include "sprite.h"
#include "object.h"

typedef struct Scene Scene;
struct Scene {
    char* name;
    Vector* objects;
    Vector* sprites;

    bool (*add_object)(Scene*, Object*);
    bool (*add_sprite)(Scene*, Sprite*);
    void (*update)(Scene*);
    void (*draw)(Scene*);
    void (*load)(Scene*);
};

void free_Scene(struct Scene* self);
Scene* new_Scene(char* name);
Scene* current_Scene();

#endif
