#ifndef VECTOR_H_
#define VECTOR_H_

#include "vc_vector.h"

typedef struct Vector Vector;

struct Vector {
    vc_vector* _vector;
    bool (*consume)(Vector*, const void*);
    bool (*push)(Vector*, const void*);
    void* (*pop)(Vector*);
    bool (*replace)(Vector*, size_t, const void*);
    void (*clear)(Vector*);
    size_t (*count)(Vector*);
    void* (*get)(Vector*, size_t);
};

void free_Vector(struct Vector* self);
Vector* new_Vector(int size, size_t obj_size, vc_vector_deleter* deleter);
Vector* new_VectorFromVC(vc_vector* vector);
#endif
