#include <graphx.h>
#include <keypadc.h>
#include <compression.h>
#include <debug.h>

#include "gfx/main_gfx.h"
#include "main.h"
#include "objects/player.h"

int main(void){
    size_t i;
    Scene* scene = new_Scene("Main");
    Sprite* sprite;
    Object* player = new_Player();
    Vector* objects = scene->objects;
    Vector* sprites = scene->sprites;
    if(!sprites->consume(sprites, new_Sprite(bm1_width, bm1_height, bm1_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm2_width, bm2_height, bm2_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm3_width, bm3_height, bm3_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm4_width, bm4_height, bm4_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm5_width, bm5_height, bm5_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm6_width, bm6_height, bm6_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm7_width, bm7_height, bm7_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm8_width, bm8_height, bm8_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm9_width, bm9_height, bm9_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm10_width, bm10_height, bm10_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm11_width, bm11_height, bm11_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm12_width, bm12_height, bm12_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm13_width, bm13_height, bm13_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm14_width, bm14_height, bm14_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm15_width, bm15_height, bm15_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm16_width, bm16_height, bm16_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm17_width, bm17_height, bm17_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm18_width, bm18_height, bm18_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm19_width, bm19_height, bm19_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm20_width, bm20_height, bm20_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm21_width, bm21_height, bm21_compressed)) ||
        !sprites->consume(sprites, new_Sprite(bm22_width, bm22_height, bm22_compressed))
    ){
        log("Failed to load sprites");
        free_Scene(scene);
        return 1;
    }
    if(!objects->consume(objects, player)){
        log("Unable to load objects");
        free_Scene(scene);
        return 1;
    }
    player = objects->get(objects, 0);
    if(player == NULL){
        log("Unable to get player");
        free_Scene(scene);
        return 1;
    }
    sprite = sprites->get(sprites, 0);
    if(sprite == NULL){
        log("Unable to get sprite");
        free_Scene(scene);
        return 1;
    }
    player->sprite = sprite;

    gfx_Begin();
    gfx_SetPalette(main_palette, sizeof_main_palette, 0);
    gfx_SetDrawBuffer();
    log("Main loop");
    scene->load(scene);
    do{
        scene->update(scene);
        kb_Scan();
        scene->draw(scene);
    }while (! (kb_Data[6] & kb_Clear));
    log("Freeing memory");
    free_Scene(scene);
    log("End graphics");
    gfx_End();
    log("Done");
    return 0;
}
